<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Scopes/Synopsis/TypeAnalysis.html -->
<!-- this view was generated by Scope -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis::TypeAnalysis</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Scope">
<div class="navigation">
<span class="normal"><a href="../global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
<!-- this part was generated by Heading -->
<h1 >Namespace <a href="../Synopsis.html" >Synopsis</a>::TypeAnalysis

</h1> <div class="doc"></div>
<!-- this part was generated by Summary -->
<div class="summary">
<div class="heading">Classes Summary:</div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/ConstEvaluator.html" >ConstEvaluator</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mConstEvaluator" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/ConstEvaluator.hh.html#line22" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Evaluate the value of a constant expression.</p>
</div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Kit.html" >Kit</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mKit" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Kit.hh.html#line18" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>creates and remembers declared types.</p>
</div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/TypeEvaluator.html" >TypeEvaluator</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mTypeEvaluator" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/TypeEvaluator.hh.html#line22" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>evaluate the type of an expression</p>
</div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Type.html" >Type</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mType" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line20" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mBuiltinType" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line35" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Enum.html" >Enum</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mEnum" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line62" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Compound.html" >Compound</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mCompound" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line69" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Class.html" >Class</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mClass" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line75" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Union.html" >Union</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mUnion" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line87" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/CVType.html" >CVType</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mCVType" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line96" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Pointer.html" >Pointer</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mPointer" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line112" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Reference.html" >Reference</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mReference" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line122" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Array.html" >Array</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mArray" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line132" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Function.html" >Function</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mFunction" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line142" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/PointerToMember.html" >PointerToMember</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mPointerToMember" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line152" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Visitor.html" >Visitor</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mVisitor" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Visitor.hh.html#line27" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Functions Summary:</div>
<div class="item"><div class="synopsis"><span class="keyword">inline</span>&#160;bool <span class="name"><a href="TypeAnalysis.html#evaluate_const_lconst.SymbolLookup_mScope_S_cconst.PTree_mNode_S_clong_A_r" >evaluate_const</a></span>(const&#160;<a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>* <span class="variable">scope</span>, const&#160;<a href="PTree/Node.html" >PTree::Node</a>* <span class="variable">node</span>, long&amp; <span class="variable">value</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/ConstEvaluator.hh.html#line46" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Evaluate the value of a constant expression.</p>
</div></div>
<div class="item"><div class="synopsis"> const&#160;<a href="SymbolLookup/Symbol.html" >SymbolLookup::Symbol</a>* <span class="name"><a href="TypeAnalysis.html#resolve_funcall_lconst.PTree_mFuncallExpr_S_cconst.SymbolLookup_mScope_S_r" >resolve_funcall</a></span>(const&#160;<a href="PTree/FuncallExpr.html" >PTree::FuncallExpr</a>* <span class="variable">funcall</span>, const&#160;<a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/OverloadResolver.hh.html#line20" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Resolve a function call in the context of the given scope.</p>
</div></div>
<div class="item"><div class="synopsis"><span class="keyword">inline</span> const&#160;<a href="TypeAnalysis/Type.html" >Type</a>* <a class="name" id="type_of_lconst.PTree_mNode_S_cconst.SymbolLookup_mScope_S_r">type_of</a>(const&#160;<a href="PTree/Node.html" >PTree::Node</a>* <span class="variable">node</span>, const&#160;<a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>* <span class="variable">s</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/TypeEvaluator.hh.html#line58" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Namespace variables Summary:</div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="BOOL">BOOL</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mBOOL" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line45" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="CHAR">CHAR</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mCHAR" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line46" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="WCHAR">WCHAR</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mWCHAR" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line47" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="SHORT">SHORT</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mSHORT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line48" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="INT">INT</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mINT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line49" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="LONG">LONG</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mLONG" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line50" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="FLOAT">FLOAT</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mFLOAT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line51" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="DOUBLE">DOUBLE</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mDOUBLE" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line52" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="UCHAR">UCHAR</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mUCHAR" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line53" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="USHORT">USHORT</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mUSHORT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line54" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="UINT">UINT</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mUINT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line55" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="ULONG">ULONG</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mULONG" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line56" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="SCHAR">SCHAR</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mSCHAR" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line57" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="SSHORT">SSHORT</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mSSHORT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line58" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="SINT">SINT</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mSINT" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line59" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="TypeAnalysis/BuiltinType.html" >BuiltinType</a> <a class="name" id="SLONG">SLONG</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mSLONG" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Type.hh.html#line60" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<!-- this part was generated by Detail -->
<div class="detail">
<div class="heading">Classes Details:</div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/ConstEvaluator.html" >ConstEvaluator</a></div> <div class="xref"><a href="../../XRef/xref31.html#Synopsis_mTypeAnalysis_mConstEvaluator" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/ConstEvaluator.hh.html#line22" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Evaluate the value of a constant expression.</p>
</div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/Kit.html" >Kit</a></div> <div class="xref"><a href="../../XRef/xref32.html#Synopsis_mTypeAnalysis_mKit" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/Kit.hh.html#line18" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>creates and remembers declared types.</p>
</div></div>
<div class="item"><div class="synopsis">class <a href="TypeAnalysis/TypeEvaluator.html" >TypeEvaluator</a></div> <div class="xref"><a href="../../XRef/xref33.html#Synopsis_mTypeAnalysis_mTypeEvaluator" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/TypeEvaluator.hh.html#line22" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>evaluate the type of an expression</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Functions Details:</div>
<div class="item"><div class="synopsis"><span class="keyword">inline</span>&#160;bool <a class="name" id="evaluate_const_lconst.SymbolLookup_mScope_S_cconst.PTree_mNode_S_clong_A_r">evaluate_const</a>(const&#160;<a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>* <span class="variable">scope</span>, const&#160;<a href="PTree/Node.html" >PTree::Node</a>* <span class="variable">node</span>, long&amp; <span class="variable">value</span>)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/ConstEvaluator.hh.html#line46" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Evaluate the value of a constant expression.
TODO: This may also return the type of the expression...</p>
</div></div>
<div class="item"><div class="synopsis"> const&#160;<a href="SymbolLookup/Symbol.html" >SymbolLookup::Symbol</a>* <a class="name" id="resolve_funcall_lconst.PTree_mFuncallExpr_S_cconst.SymbolLookup_mScope_S_r">resolve_funcall</a>(const&#160;<a href="PTree/FuncallExpr.html" >PTree::FuncallExpr</a>* <span class="variable">funcall</span>, const&#160;<a href="SymbolLookup/Scope.html" >SymbolLookup::Scope</a>*)  </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/TypeAnalysis/OverloadResolver.hh.html#line20" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Resolve a function call in the context of the given scope.</p>
</div></div>
</div><!-- detail -->

<div class="logo">Generated on Thu Apr 16 16:27:43 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
